(****************************************************************************)
(*.                                                                         *)
(*. Owner........: (c) 1995 TELEOMED, Hauptstrasse 87, CH-5026 Densbren    *)
(*.                                                                         *)
(*. ModulName....: DM_File.PAS                                              *)
(*. Modul-Type...: Unit                                                     *)
(*. Created Date.: 20.3.95                                                  *)
(*.                                                                         *)
(*. Author.......: T. Mller    TM                                          *)
(*. Respons......: T. Mller    TM                                          *)
(*. Project......: Demo-program for tmUtils                                 *)
(*. Version......: 9.90                                                     *)
(*. Short........: Menu Files                                               *)
(*. Further Docus:                                                          *)
(*.                                                                         *)
(*. Description..: Opens a File with standard TmFileDialog                  *)
(*.                                                                         *)
(*. Modified: Date     What/Line                                     Author *)
(*.           ------------------------------------------------------------- *)
(*.                                                                         *)
(****************************************************************************)
{$I TmUtil.INC}
unit DM_File;
interface

procedure OpenFile;

implementation
uses Dos,
     Drivers,
     TmHeader,
     TmText,
     TmFunct,
     TmFDialo,
     TmDialog,
     TmMsgBox,
     DM_Help,
     DM_gVar;

  (**************************************************************************)
  (*: Proc      : OpenFile                                                  *)
  (*: short     : Opens a File with Object TmFileDialog                     *)
  (*: Param -In : -                                                         *)
  (*:       -OUT: -                                                         *)
  (**************************************************************************)
  procedure OpenFile;
  var
    Titel,s     : String;
    FileDia     : ^TmFileDialog;
    Ende        : Boolean;
    ExitCommand : Word;
    Dir,Name,Ext: String;
    CurDir      : PathStr;
    ev          :tEvent;
  begin
    Titel := 'Select File';
    GetDir(0, CurDir);
    New(FileDia);
    FileDia^.Init(60,60,Titel,'*.*',gColors);
    FileDia^.Draw;
    Ende := False;
    repeat
      FileDia^.Process(ev);
      case ev.Command of
        kbF1       : ShowHelp(chOpen);
        kbESC      : Ende:=True;
        kbEnter    : begin
                       s:=FileDia^.GetSelectedFile;
                       if ExistFile(s) then
                       begin
                         Ende:=True;
                         gDBFFile := s;
                       end
                       else
                         MBox('E','Not a valid Filename $1;'+
                                  'Enter a valid name or choose one;'+
                                  'from the ListBox.',s,gColors);
                     end;
      end;
    until Ende;
    FileDia^.Erase;
    FileDia^.Done;
    Dispose(FileDia);
    ChDir(CurDir);
  end;

end.
