(****************************************************************************)
(*.                                                                         *)
(*. Owner........: (c) 1995 TELEOMED, Hauptstrasse 87, CH-5026 Densbren    *)
(*.                                                                         *)
(*. ModulName....: DM_HELP.PAS                                              *)
(*. Modul-Type...: Unit                                                     *)
(*. Created Date.: 21.3.95                                                  *)
(*.                                                                         *)
(*. Machine Type.: IBM-PC >= 286                                            *)
(*. Target OS....: MS-DOS                                                   *)
(*. Language.....: BORLAND PASCAL 7.01                                      *)
(*. Author.......: T. Mller    TM                                          *)
(*. Respons......: T. Mller    TM                                          *)
(*.                                                                         *)
(*. Project......: Demo TmUtils                                             *)
(*. Version......: v1.00                                                    *)
(*. Short........: HelpFunction and InfoBox                                 *)
(*. Further Docus:                                                          *)
(*.                                                                         *)
(*. Description..: Helpfunction and InfoBox                                 *)
(*.                                                                         *)
(*. Modified: Date     What/Line                                     Author *)
(*.           ------------------------------------------------------------- *)
(*.                                                                         *)
(****************************************************************************)
{$I TmUtil.INC}
unit DM_Help;

interface

{Exported Functions}
procedure ShowHelp(pHelpTopic:Word);
procedure ShowInfo;


implementation
uses
  Drivers,Graph,OpDate,
  TmHeader,TmText,TmFunct,TmObject,TmHelp,
  DM_gVar;

  (**************************************************************************)
  (*  Proc       : ShowHelp                                                 *)
  (*  Short      : Show Helpwindow with text from Topic pHelpTopicc         *)
  (*  Param -In  : pHelpTopic: Help-TopicNr                                 *)
  (*        -Out : -                                                        *)
  (**************************************************************************)
  procedure ShowHelp(pHelpTopic:Word);
  begin
    HelpWin(20,50,                 {upper Left corner (pixels)}
            20,                    {No of lines in window}
            70,                    {Len of line (chars)}
            'TM',                  {Helpfile incl. path}
            pHelpTopic,            {No of HelpTopic}
            gColors);              {ColorSet to use}
  end;

  (**************************************************************************)
  (*  Proc       : ShowInfo                                                 *)
  (*  Short      : Shows Informationen about TELEOMED.                      *)
  (*               Shows free Mem and largest mem block.                    *)
  (*  Param -In  : -                                                        *)
  (*        -Out : -                                                        *)
  (**************************************************************************)
  procedure ShowInfo;
  var
    str1,str2     : String[10];
    Ux,Uy,
    x,y,
    xLen,yLen     : Word;
    TELEO         : array[1..11] of PointType;
    ev            : tEvent;
  begin
    HideMouse;
    x := 150;
    y := 100;
    xLen := 250;
    yLen := 200;

    Ux := x+10;
    Uy := y+yLen-30;

    TELEO[1].x  := Ux;
    TELEO[1].y  := Uy;
    TELEO[2].x  := Ux+160;
    TELEO[2].y  := Uy;
    TELEO[3].x  := Ux+170;
    TELEO[3].y  := Uy-2;
    TELEO[4].x  := Ux+180;
    TELEO[4].y  := Uy-4;
    TELEO[5].x  := Ux+190;
    TELEO[5].y  := Uy-9;
    TELEO[6].x  := Ux+200;
    TELEO[6].y  := Uy-13;
    TELEO[7].x  := Ux+210;
    TELEO[7].y  := Uy-16;
    TELEO[8].x  := Ux+220;
    TELEO[8].y  := Uy-15;
    TELEO[9].x  := Ux+230;
    TELEO[9].y  := Uy-11;
    TELEO[10].x := Ux+230;
    TELEO[10].y := Uy+5;
    TELEO[11].x := Ux;
    TELEO[11].y := Uy+5;

    Str(MemAvail:10,str1);
    Str(MaxAvail:10,str2);

    PaintButton(x,y,xLen,yLen,Out3D,True,gColors.DLGBg);
    PaintButton(x+5,y+5,xLen-10,15,In3D,True,gColors.TitelBg);
    PaintButton(x+5,y+25,xLen-10,yLen-30,In3D,True,gColors.DLGBg);
    SetColor(White);
    TextXY(x+5+((xLen-10-TextWidth(cInf000)) div 2),y+10,cInf000);

    SetTextStyle(0,0,2);
    OutTextXY(x+5+((xLen-10-11*16) div 2),y+40,'DEMO TmUtil');
    SetTextStyle(0,0,1);
    SetColor(gColors.DLGTx);
    OutTextXY(x+5+((xLen-10-28*8) div 2),y+67,'DEMO-Application with TmUtil');
    OutTextXY(x+5+((xLen-10-12*8) div 2),y+79,'Version 1.0');

    SetTextStyle(2,0,4);
    {$IFDEF DPMI}
    OutTextXY(x+80,y+110,'Protected Mode');
    {$ELSE}
    OutTextXY(x+95,y+110,'Real Mode');
    {$ENDIF}
    OutTextXY(x+35,y+125,ctMemAvail);
    OutTextXY(x+35,y+135,ctMaxAvail);
    OutTextXY(x+135,y+125,': '+TrimL(str1)+' Bytes');
    OutTextXY(x+135,y+135,': '+TrimL(str2)+' Bytes');

    SetColor(White);
    OutTextXY(x+10,Uy-12,'(c) 1995 TELEOMED');
    OutTextXY(x+10,Uy+8,'TELEOMED, Medzinal-Software    T. Mller');
    SetTextStyle(0,0,1);
    if gColNr=1 then
    begin
      SetColor(LightGreen);
      SetFillStyle(SolidFill,LightGreen);
    end
    else
    begin
      SetColor(White);
      SetFillStyle(SolidFill,White);
    end;
    FillPoly(11,TELEO);

    ShowMouse;
    repeat
      GetEvent(ev);
    until Ev.What in [evKeyDown,evMouse];

    HideMouse;
    ClearWindow(x,y,xLen,yLen,gColors.ScreenBg);
    ShowMouse;
  end;


end.
