(****************************************************************************)
(*.                                                                         *)
(*. Owner........: (c) 1995 TELEOMED, Hauptstrasse 87, CH-5026 Densbren    *)
(*.                                                                         *)
(*. ModulName....: DM_Main.PAS                                              *)
(*. Modul-Type...: Unit                                                     *)
(*. Created Date.: 20.3.95                                                  *)
(*.                                                                         *)
(*. Author.......: T. Mller    TM                                          *)
(*. Respons......: T. Mller    TM                                          *)
(*. Project......: Demo-program for tmUtils                                 *)
(*. Version......: 9.90                                                     *)
(*. Short........: Menu - for TmUtil-Demo                                   *)
(*. Further Docus:                                                          *)
(*.                                                                         *)
(*. Description..: Define Appl-Object with Menu. Main-Process               *)
(*.                                                                         *)
(*. Modified: Date     What/Line                                     Author *)
(*.           ------------------------------------------------------------- *)
(*.                                                                         *)
(****************************************************************************)
{$I TmUtil.INC}
unit DM_Main;

interface

uses Drivers,TmAppl;

type
  {Application-object for Demo-program}
  MyAppl  = object(TmApplication)
              procedure InitMenu; virtual;
              procedure Process(var pEvent:tEvent); virtual;
            end;

var
  DemoAppl : MyAppl;  {Exported}

implementation
uses
  GRAPH,OpDate,
  TmHeader,TmFunct,TmText,TmMenus,TmHelp,TmMsgBox,
  DM_gVar,DM_File,DM_Obj,DM_Optio,DM_Help;

var
 Mnu     : PTmMenu;

  (**************************************************************************)
  (*  Proc       : InitMenu                                                 *)
  (*  Short      : Init Menu with all submenues                             *)
  (*  Param -In  : -                                                        *)
  (*        -Out : -                                                        *)
  (**************************************************************************)
  procedure MyAppl.InitMenu;
  var
   Opt     : Integer;
  begin
    Opt := NO_3D or NO_SAVE_BG;
    Mnu := inherited AddMenu(2,16,GetMaxX-4,14,Opt);
    with Mnu^ do
    begin
      AddItem( 10,'~Files',False,0,'File-Management / Exit Programm',chFile);
      AddSubMenu(5,15,Opt);
      AddSubItem('Open File',False,cmOpen,'Open file',chOpen);
      AddSubSeparator;
      AddSubItem('~Quit',False,cmCancel,'Exit TmUtil - Demo',chQuit);

      AddItem(60,'~Object-Demos',False,0,'Text-, DBF-Editor, Controls, Fields and Lists',chObj);
      AddSubMenu(55,15,Opt);
      AddSubItem('~Text-Editor',False,2000,'',chEdit);
      AddSubSeparator;
      AddSubItem('~DBF-Editor',False,2100,'',chDBF);
      AddSubSeparator;
      AddSubItem('~Buttons,RadioGroups,CheckBoxes',False,2200,'',chButt);
      AddSubSeparator;
      AddSubItem('~Fields,ListBoxes,ComboBoxes',False,2300,'',chCtrl);

      AddItem(170,'~MessageBoxes',False,0,'',chMsg);
      AddSubMenu(165,15,Opt);
      AddSubItem('~Info      MessageBox',False,3000,'',chMsg1);
      AddSubItem('~Error     MessageBox',False,3100,'',chMsg2);
      AddSubItem('De~cission MessageBox',False,3200,'',chMsg3);
      AddSubSeparator;
      AddSubItem('I~nfo      MessageBox with help',False,3300,'',chMsg4);
      AddSubItem('E~rror     MessageBox with help',False,3400,'',chMsg5);
      AddSubItem('Decission ~MessageBox with help',False,3500,'',chMsg6);

      AddItem(280,'~Appl.Options',False,0,'',chSetup);
      AddSubMenu(275,15,Opt);
      AddSubItem('~Colors,StatusBar',False,4100,'',chSetup1);
      AddSubSeparator;
      AddSubItem('~ScreenSaver',False,4200,'',chSetup2);
      AddSubSeparator;
      AddSubItem('Create ~HelpFile',False,4300,'',chSetup3);

      AddItem(400,'~TmUtil-Test',False,0,'',chTest);
      AddSubMenu(395,15,Opt);
      AddSubItem('~GS-Index-Test',False,4400,'',chTest1);

      AddItem(600,'~Help',False,0,'',chHelp);
      AddSubMenu(575,15,Opt);
      AddSubItem('~Info',False,5000,'',chHelp1);
      AddSubSeparator;
      AddSubItem('~Order',False,5100,'',chHelp2);
    end;
  end;

  (**************************************************************************)
  (*  Proc       : Process                                                  *)
  (*  Short      : Main process-loop for Demo-program                       *)
  (*  Param -In  : var pEvent: Record with Event-Information                *)
  (*        -Out : -                                                        *)
  (**************************************************************************)
  procedure MyAppl.Process(var pEvent:tEvent);
  var
    Ende:Boolean;
  begin
    Ende:=False;
    repeat
      inherited Process(pEvent);

      {Events from keyboard}
      if pEvent.What=evKeyBoard then
      case pEvent.KeyCode of
        kbEnter   : Ende := True;
        kbESC     : if MBox('D',cDec001,'',gColors) then Ende:=True;
        kbF1      : ShowHelp(Mnu^.GetHelpTopic);
      end;

      {Menu-Events}
      if pEvent.What=evMessage then
      case pEvent.Command of
        cmCancel : if MBox('D',cDec001,'',gColors) then Ende:=True;
        cmOpen   : OpenFile;
        2000     : TestEditor;
        2100     : TestDBEdit;
        2200     : CtrlDLG;
        2300     : FieldDLG;

        3000     : MBox('I','This is an Information;MessageBox!;You can insert Text like ($1);'+
                            'and you can have as many lines;as you want..',DateToDateString('dd. NNNN yyyy',ToDay),gColors);
        3100     : MBox('E','This is an Error;MessageBox!','',gColors);
        3200     : MBox('D','This is a Decission MessageBox!; ;Press Yes or No','',gColors);
        3300     : MBoxHelp('IH','This is an Information;MessageBox;with Help-button','',gColors,ShowHelp,chMsg41);
        3400     : MBoxHelp('EH','This is an Error;MessageBox;with Help-button','',gColors,ShowHelp,chMsg41);
        3500     : MBoxHelp('DH','This is an Decission MessageBox;with Help-button','',gColors,ShowHelp,chMsg41);
        4100     : Setup;
        4200     : ScrSave;
        4300     : MakeHelp('TM',gColors);

        5000     : ShowInfo;
        5100     : ShowHelp(chHelp2);
      else
        MBox('I',cInf001,'',gColors);
      end;
    until Ende;
  end;

end.
