(****************************************************************************)
(*.                                                                         *)
(*. Owner........: (c) 1995 TELEOMED, Hauptstrasse 87, CH-5026 Densbren    *)
(*.                                                                         *)
(*. ModulName....: DM_Opj.PAS                                               *)
(*. Modul-Type...: Unit                                                     *)
(*. Created Date.: 20.3.95                                                  *)
(*.                                                                         *)
(*. Author.......: T. Mller    TM                                          *)
(*. Respons......: T. Mller    TM                                          *)
(*. Project......: Demo-program for tmUtils                                 *)
(*. Version......: 9.90                                                     *)
(*. Short........: Menue Object-Demos                                       *)
(*. Further Docus:                                                          *)
(*.                                                                         *)
(*. Description..: Some TmUtil-Objects like TextEditor, Controlls, Fields,  *)
(*.                all kind of ListBoxes and a new object for editing dBase *)
(*.                files witch is still under construction.                 *)
(*.                                                                         *)
(*. Modified: Date     What/Line                                     Author *)
(*.           ------------------------------------------------------------- *)
(*.                                                                         *)
(****************************************************************************)
{$I TmUtil.INC}
unit DM_Obj;
interface

{exported functions}
procedure TestEditor;
procedure TestDBEdit;
procedure CtrlDLG;
procedure FieldDLG;


implementation
uses
  Dos,Drivers,Strings,Graph,
  TmHeader,TmText,TmFunct,TmEdit,TmDialog,TmMsgBox,
  DM_Help,DM_gVar;

  (**************************************************************************)
  (*: Proc      : TestEditor                                                *)
  (*: short     : A short example of using the TextEditor                   *)
  (*: Param -In : -                                                         *)
  (*:       -OUT: -                                                         *)
  (**************************************************************************)
  procedure TestEditor;
  var
    DiaBox : ^TmDialogBox;
    Buf     : pChar;
    TEdi    : PTmTextEditor;
    Ende    : Boolean;
    ev      : tEvent;
    s       : string;
  begin
    GetMem(Buf,6000);
    FillChar(Buf^,6000,#0);
    s := 'Hello world! This is a small Text where you can practice.'+
         'And this is the second line.';
    StrPCopy(Buf,s);
    New(DiaBox);
    with DiaBox^ do
    begin
      Init(60,100,520,300,'TextEditor',gColors,0);

      {DialogButtons}
      AddDLGButton(50, 270,0,0,cDLGOK,kbEnter,True,0);
        AddHelpText(chDLGOK);
      AddDLGButton(150,270,0,0,cDLGBreak,kbESC,False,SMALL_FONT);
        AddHelpText(chDLGBreak);
      AddDLGButton(250,270,0,0,cDLGHelp,kbF1,False,SMALL_FONT);
        AddHelpText(chDLGHelp);

      {TextEditor}
      TEdi:=AddTextEditor(20,40,20,60,Buf,FRAME_IN);
        AddFieldLabel(20,30,'Text-~Editor');
        AddHelpText('Here you can edit up to 20 lines.');
        TEdi^.SetStatusLine(True);
      SetFirstFocus(4);
      Draw;

      Ende := False;
      repeat
        Process(ev);

        if ev.What=evKeyBoard then
        case ev.KeyCode of
          kbEnter   : Ende := True; {here you can save the edited text}
          kbESC     : Ende := True;
          kbF1      : ShowHelp(chEdit);
        end;
      until Ende;
      Erase;
    end;
    Dispose(DiaBox,Done);
    FreeMem(Buf,6000);
  end;


  (**************************************************************************)
  (*: Proc      : TestDBEdit                                                *)
  (*: short     : An expl. of a DBedit for dBase files (still under constr.)*)
  (*: Param -In : -                                                         *)
  (*:       -OUT: -                                                         *)
  (**************************************************************************)
  procedure TestDBEdit;
  var
    Ende   : Boolean;
    ev     : tEvent;
    DiaBox : ^TmDialogBox;
  begin
    if not(ExistFile(gDBFFile)) then
    begin
       MBox('E','No database selected','',gColors);
       exit;
    end;

    New(DiaBox);
    with DiaBox^ do
    begin
      Init(30,70,GetMaxX-60,GetMaxY-140,'Expl. DialogBox for DBEdit '+gDBFFile,gColors,0{NO_SAVE_BG});

      {DialogButtons}
      AddDLGButton(50, 310,0,0,cDLGOK,kbEnter,True,0);
        AddHelpText(chDLGOK);
      AddDLGButton(150, 310,0,0,cDLGBreak,kbESC,False,SMALL_FONT);
        AddHelpText(chDLGBreak);
      AddDLGButton(250,310,0,0,cDLGHelp,kbF1,False,SMALL_FONT);
        AddHelpText(chDLGHelp);

      {DBEdit}
      AddDBEditor(10,30,25,65,CutExtension(gDBFFile),FRAME_IN);
        AddFieldLabel(10,20,'DB~Edit');
        AddHelpText('DBEdit is still under construction...');

      SetFirstFocus(4);
      Draw;

      Ende := False;
      repeat
        Process(ev);

        if ev.What=evKeyBoard then
        case ev.KeyCode of
          kbEnter   : Ende := True;
          kbESC     : Ende := True; {Finish, do nothing}
          kbF1      : ShowHelp(chDBF);
        end;
      until Ende;
      Erase;
    end;
    Dispose(DiaBox,Done);
  end;


  (**************************************************************************)
  (*: Proc      : CtrlDLG                                                   *)
  (*: short     : Some Control-Objects                                      *)
  (*: Param -In : -                                                         *)
  (*:       -OUT: -                                                         *)
  (**************************************************************************)
  procedure CtrlDLG;
  var
    AnzMess     : Byte;
    Bereich     : Byte;
    Beurt       : Boolean;
    MessWert    : Boolean;
    NormWert    : Boolean;
    PrSel       : String[15];
    Ende        : Boolean;
    Ev          : tEvent;
    DiaBox      : ^TmDialogBox;
  begin
    New(DiaBox);

    AnzMess  := 4;
    Bereich  := 2;
    Beurt    := False;
    MessWert := True;
    NormWert := False;
    PrSel    := '1,4,6-12';

    with DiaBox^ do
    begin
      Init(75,70,490,340,'Expl. Controls',gColors,0);

      {DialogButtons}
      AddDLGButton( 70,310,0,0,cDLGOK,kbEnter,True,0);
        AddHelpText(chDLGOK);
      AddDLGButton(210,310,0,0,cDLGBreak,kbESC,False,0);
        AddHelpText(chDLGBreak);
      AddDLGButton(350,310,0,0,cDLGHelp,kbF1,False,0);
        AddHelpText(chDLGHelp);

      {kind of ToolBar}
      AddFrame(5,18,480,18,'',FRAME_OUT);
      AddDLGButton( 10,21,40,12,'~1Tool',0,False,TOOL_BUTTON or SMALL_FONT);
        AddHelpText('ToolButton 1 (Kind of ToolBar)');
      AddDLGButton( 51,21,40,12,'~2Tool',0,False,TOOL_BUTTON or SMALL_FONT);
        AddHelpText('ToolButton 2 (Kind of ToolBar)');
      AddDLGButton( 92,21,40,12,'~3Tool',0,False,TOOL_BUTTON or SMALL_FONT);
        AddHelpText('ToolButton 3 (Kind of ToolBar)');

      {RadioButtons}
      AddRadioGroup(10, 60,180,75,AnzMess,FRAME_IN);
        AddFieldLabel(10, 50,'RadioGrup');
      AddRadioButton(15,70,nil, '~First Value'  ,45,71,0);
      AddRadioButton(15,85,nil, '~Second Value',45,86,0);
      AddRadioButton(15,100,nil, '~Third Values',45,101,0);
      AddRadioButton(15,115,nil, 'F~ourth Values',45,116,0);

      {AddFrame & CheckBox}
      AddFrame(220,60,220,75,'AddFrame & CheckBox',NO_3D or FRAME_EMPTY);
      AddCheckBox(230,70,Beurt,0);
        AddFieldLabel(250,71,'~Some stuff');
      AddCheckBox(230,90,MessWert,0);
        AddFieldLabel(250,91,'Some ~extra stuff');
      AddCheckBox(230,110,NormWert,FIELD_PROT);
        AddFieldLabel(250,111,'S~ome secrete stuff');

      {RadioGroup & RadioEdit}
      AddRadioGroup(10, 170,260,100,Bereich,FRAME_IN);
      AddFieldLabel(10, 160,'RadioGroup & RadioEdit');
      AddRadioButton(15,180,nil, 'A~ll Pages'  ,45,181,0);
        AddHelpText('All pages will be printed');
      AddRadioButton(15,195,nil, 'C~urrent page',45,196,0);
        AddHelpText('The current visible page will be printed');
      AddRadioEdit(15,210,nil, 'Sele~ction:',45,210,130,210,PrSel,15,nil,FRAME_IN);
        AddHelpText('Enter all pages you want to print out.');
      AddStaticText(45,225,26,'Single pages has to be separeted by',gColors.DLGTx,gColors.EditBg,SMALL_FONT);
      AddStaticText(45,238,26,'coma (,), ranges by (-)',gColors.DLGTx,gColors.EditBg,SMALL_FONT);
      AddStaticText(45,250,26,'Expl. z.B.: 1,4,8,9-16',gColors.DLGTx,gColors.EditBg,SMALL_FONT);

      {Some Buttons}
      AddDLGButton(300,170,110,0,'S~mall-Font-Button',0,False,SMALL_FONT);
      AddDLGButton(300,200,150,50,'~Big Button',0,False,0);
      AddDLGButton(300,260,0,0,'Flat Butt~on',0,False,TOOL_BUTTON or SMALL_FONT);

      {Static Line}
      AddLine(10,300,480,300);

      SetFirstFocus(8);
      Draw;

      Ende := False;
      repeat
        Process(ev);
        if ev.What=evKeyBoard then
        case ev.KeyCode of
          kbEnter   : Ende := True;
          kbESC     : Ende := True;
          kbF1      : ShowHelp(chButt);
        end;
      until Ende;
      Erase;
    end;
    Dispose(DiaBox,Done);
  end;



  {Itemproc to fill the ListBox}
  procedure ListBoxItem(pItemNo:Word;var pItemStr:String);
  begin
    pItemStr := ' ListBox Item # '+IntToStr(pItemNo);
  end;

  {Itemproc to fill the ComboBox}
  procedure ComboBoxItem(pItemNo:Word;var pItemStr:String);
  begin
    pItemStr := 'ComboBox Item # '+IntToStr(pItemNo);
  end;

  {Itemproc to fill the ListFild}
  procedure ListFieldItem(pItemNo:Word;var pItemStr:String);
  begin
    pItemStr := 'ListField Item # '+IntToStr(pItemNo);
  end;

  (**************************************************************************)
  (*: Proc      : FieldDLG                                                  *)
  (*: short     : Some Fields and Lists                                     *)
  (*: Param -In : -                                                         *)
  (*:       -OUT: -                                                         *)
  (**************************************************************************)
  procedure FieldDLG;
  var
    Ende    : Boolean;
    ev      : tEvent;
    DiaBox  : ^TmDialogBox;
    ST      : String;
    int1    : LongInt;
    Date1   : LongInt;
    Time1   : LongInt;
    real1   : Real;

  begin
    ST      := 'Hello world';
    int1    := 12345;
    real1   := 123.45;
    Date1   := 65324;
    Time1   := 12346;

    New(DiaBox);
    with DiaBox^ do
    begin
      Init(75,70,490,340,'Expl. Fields and Lists',gColors,0);

      {DialogButtons}
      AddDLGButton( 70,310,0,0,cDLGOK,kbEnter,True,0);
        AddHelpText(chDLGOK);
      AddDLGButton(210,310,0,0,cDLGBreak,kbESC,False,0);
        AddHelpText(chDLGBreak);
      AddDLGButton(350,310,0,0,cDLGHelp,kbF1,False,0);
        AddHelpText(chDLGHelp);

      {Div. Fields}
      AddIntField(70,30,int1,8,FRAME_IN,nil);
        AddFieldLabel(10,31,'~Integer');
        AddHelpText('Enter an integer value');
      AddRealField(70,50,real1,8,2,FRAME_IN,nil);
        AddFieldLabel(10,51,'~Real');
        AddHelpText('Enter a real value');
      AddDateField(70,70,Date1,FRAME_IN,nil);
        AddFieldLabel(10,71,'~Date');
        AddHelpText('Enter a date (dd.mm.yy.)');
      AddTimeField(70,90,Time1,FRAME_IN,nil);
        AddFieldLabel(10,91,'~Time');
        AddHelpText('Enter a time (hh:mm:ss) ein');
      AddTextField(70,110,ST,21,FRAME_IN,nil);
        AddFieldLabel(10,111,'~String');
        AddHelpText('Enter a string max. 21 chars');

      {ListBox}
      AddListBox(270,40,200,8,21,ListBoxItem,nil,FRAME_IN or MULTI_SELECT);
        AddFieldLabel(270,30,'List~Box');
        AddHelpText('Choose one or more (space-bar) elements from the ListBox');

      {ListField}
      AddListField(10,170,4,5,25,ListFieldItem,nil,FRAME_IN or CLOSE_ON_LEAVE);
        AddFieldLabel(10,160,'~ListField');
        AddHelpText('Choose an element from the ListField');

      {ComboBox}
      AddComboBox(270,170,ST,21,nil,2000,10,ComboBoxItem,nil,FRAME_IN or cbCAN_OPEN or CLOSE_ON_LEAVE);
        AddFieldLabel(270,160,'C~omboBox');
        AddHelpText('Choose an element or create a new one');

      {Static Line}
      AddLine(10,300,480,300);

      SetFirstFocus(4);
      Draw;

      Ende := False;
      repeat
        Process(ev);

        if ev.What=evKeyBoard then
        case ev.KeyCode of
          kbEnter   : Ende := True;
          kbESC     : Ende := True;
          kbF1      : ShowHelp(chCtrl);
        end;
      until Ende;
      Erase;
    end;
    Dispose(DiaBox,Done);
  end;


end.
