(****************************************************************************)
(*.                                                                         *)
(*. Owner........: (c) 1995 TELEOMED, Hauptstrasse 87, CH-5026 Densbren    *)
(*.                                                                         *)
(*. ModulName....: DEM_Opt.PAS                                              *)
(*. Modul-Type...: Unit                                                     *)
(*. Created Date.: 20.3.95                                                  *)
(*.                                                                         *)
(*. Author.......: T. Mller    TM                                          *)
(*. Respons......: T. Mller    TM                                          *)
(*. Project......: Demo-program for tmUtils                                 *)
(*. Version......: 9.90                                                     *)
(*. Short........: Setup- for TmUtil-Demo                                   *)
(*. Further Docus:                                                          *)
(*.                                                                         *)
(*. Description..: ChangeColor, StatusBar on/off, and ScreenSaver.          *)
(*.                                                                         *)
(*. Modified: Date     What/Line                                     Author *)
(*.           ------------------------------------------------------------- *)
(*.                                                                         *)
(****************************************************************************)
{$I TmUtil.INC}
unit DM_Optio;

interface

{Exported Procedures}
procedure Setup;
procedure ScrSave;


implementation
uses Drivers,
     TmHeader,
     TmText,
     TmScrSaver,TmDialog,
     DM_Main,DM_Help,DM_gVar;

  (**************************************************************************)
  (*  Proc       : Setup                                                    *)
  (*  Short      : Setup for ColorSet and StatusBar                         *)
  (*  Param -In  : -                                                        *)
  (*        -Out : -                                                        *)
  (**************************************************************************)
  procedure Setup;
  var
    Ende        : Boolean;
    DiaBox      : PTmDialogBox;
    Farbe       : Byte;
    StZeile     : Byte;
    ev          : tEvent;
  begin
    New(DiaBox);
    Farbe  := 1;
    StZeile:= 1;

    with DiaBox^ do
    begin
      Init(157,130,325,140,'General Options',gColors,NO_SAVE_BG);
      AddDLGButton( 32,110,0,0,cDLGSave ,kbEnter,True,0);
      AddDLGButton(127,110,0,0,cDLGBreak,kbESC,False,0);
      AddDLGButton(222,110,0,0,cDLGHelp ,kbF1,False,0);

      AddRadioGroup(20,40,130,50,gColNr,FRAME_IN);
      AddFieldLabel(20,30,'ColorSet');
      AddRadioButton(30,50,nil,'~Color'    ,50,51,0);
      AddRadioButton(30,70,nil,'~Monochrom',50,71,0);

      AddRadioGroup(175,40,130,50,gStatBar,FRAME_IN);
      AddFieldLabel(175,30,'StatusBar');
      AddRadioButton(185,50,nil,'~Show',205,51,0);
      AddRadioButton(185,70,nil,'~Hide',205,71,0);

      SetFirstFocus(4);
      Draw;
      Ende := False;
      repeat
        Process(ev);

        if ev.What=evKeyBoard then
        case ev.KeyCode of
          kbESC   : Ende := True;
          kbF1    : ShowHelp(401);
          kbEnter : begin
                    if gColNr=1 then
                     gColors     := DefColors
                    else
                     gColors     := MonoColors;

                    if gStatBar=1 then
                    begin
                      if cStatusLn=nil then
                      begin
                        DemoAppl.InitStatusLine;
                        DemoAppl.DrawStatusLn;
                      end;
                    end
                    else DemoAppl.DoneStatusLn;
                    DemoAppl.SetColors(gColors);
                    Ende := True;
                 end;
        end;
      until Ende;
      Erase;
    end;
    Dispose(DiaBox,Done);
  end;

  (**************************************************************************)
  (*  Proc       : ScrSave                                                  *)
  (*  Short      : Setup Screen-Saver                                       *)
  (*  Param -In  : -                                                        *)
  (*        -Out : -                                                        *)
  (**************************************************************************)
  procedure ScrSave;
  var
    Ende        : Boolean;
    DiaBox      : PTmDialogBox;
    ScrTim      : Byte;
    ev          : tEvent;
  begin
    New(DiaBox);
    ScrTim := 3;
    with DiaBox^ do
    begin
      Init(165,110,310,240,'Screen-Saver options',gColors,NO_SAVE_BG);
      AddDLGButton( 25,205,0,0,cDLGSave ,kbEnter,True,0);
      AddDLGButton(120,205,0,0,cDLGBreak,kbESC,False,0);
      AddDLGButton(215,205,0,0,cDLGHelp ,kbF1,False,0);

      AddFrame(20,34,270,145,'ScreenSaver',NO_3D);
      AddRadioGroup(25,40,130,130,ScrTim,FRAME_IN);
      AddRadioButton(30, 50,nil,'~Off'        ,55,51,0);
      AddRadioButton(30, 70,nil,'~30 seconds',55,71,0);
      AddRadioButton(30, 90,nil,'~1  minute'  ,55,91,0);
      AddRadioButton(30,110,nil,'~2  minutes' ,55,111,0);
      AddRadioButton(30,130,nil,'~5  minutes' ,55,131,0);
      AddRadioButton(30,150,nil,'1~0 minutes' ,55,151,0);
      AddDLGButton(180,100,0,0,'~Test' ,1000,False,0);

      SetFirstFocus(5);
      Draw;
      Ende := False;
      repeat
        Process(ev);

        if ev.What=evKeyBoard then
        case ev.KeyCode of
          1000    : ShowLogo;
          kbESC   : Ende := True;
          kbF1    : ShowHelp(402);
          kbEnter : begin
                    case ScrTim of
                      1 : cScrTimer:=0;
                      2 : cScrTimer:=30;
                      3 : cScrTimer:=60;
                      4 : cScrTimer:=120;
                      5 : cScrTimer:=300;
                      6 : cScrTimer:=600;
                    else  cScrTimer:=60;
                    end;
                    Ende := True;
                 end;
        end;
      until Ende;
      Erase;
    end;
    Dispose(DiaBox,Done);
  end;

end.
